require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module Request
    module Request
      class RequestAttributes < UU::OS::REST::DTO

        # Type of the artifact.
        attr_accessor :uri

        attr_accessor :name

        # Code of the artifact.
        attr_accessor :code

        attr_accessor :description

        attr_accessor :location_uri

        attr_accessor :organizational_unit_uri

        # @deprecated URI of the company where artifact is located.
        attr_accessor :company_uri

        attr_accessor :meta_artifact_uri

        # URI of the competent role.
        attr_accessor :competent_role_uri

        attr_accessor :artifact_type

        attr_accessor :security_level

        # Creation stamp of the artifact.
        attr_accessor :creation_stamp

        # Creation time of the artifact.
        attr_accessor :creation_time

        # Modification stamp of the artifact.
        attr_accessor :modification_stamp

        # Modification time of the artifact.
        attr_accessor :modification_time
        
        # @deprecated Use {#version} instead.
        attr_accessor :revision
        
        # Version of the request.
        attr_accessor :version

        attr_accessor :entity_type_uri

        attr_accessor :subject_artifact_uri

        # Layout of the artifact.
        attr_accessor :submitter_uri

        # URI of the artifact container.
        attr_accessor :author_uri

        # URI of the artifact or the sheet where the user started the usecase for creating this request.
        # Nil in case of session-free-link navigation or when the artifact or the sheet has been deleted.
        attr_accessor :referrer_artifact_uri

        # Name of the artifact.
        attr_accessor :sent_time
        
        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def  code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def location_uri
          attributes[:locationUri]
        end

        def location_uri=(val)
          if val
            attributes[:locationUri] = UU::OS::UESURI.new(val)
          else
            attributes[:locationUri] = nil
          end
        end

        def organizational_unit_uri
          attributes[:organizationalUnitUri]
        end

        def organizational_unit_uri=(val)
          if val
            attributes[:organizationalUnitUri] = UU::OS::UESURI.new(val)
          else
            attributes[:organizationalUnitUri] = nil
          end
        end

        def company_uri
          attributes[:companyUri]
        end

        def company_uri=(val)
          if val
            attributes[:companyUri] = UU::OS::UESURI.new(val)
          else
            attributes[:companyUri] = nil
          end
        end

        def meta_artifact_uri
          attributes[:metaArtifactUri]
        end

        def meta_artifact_uri=(val)
          if val
            attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:metaArtifactUri] = nil
          end
        end

        def competent_role_uri
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val)
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def artifact_type
          attributes[:artifactType]
        end

        def artifact_type=(val)
          attributes[:artifactType] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def creation_stamp
          attributes[:creationStamp]
        end

        def creation_stamp=(val)
          attributes[:creationStamp] = val
        end

        def creation_time
          attributes[:creationTime]
        end

        def creation_time=(val)
          attributes[:creationTime] = val
        end

        def modification_stamp
          attributes[:modificationStamp]
        end

        def modification_stamp=(val)
          attributes[:modificationStamp] = val
        end

        def modification_time
          attributes[:modificationTime]
        end

        def modification_time=(val)
          attributes[:modificationTime] = val
        end

        def revision
          attributes[:version]
        end

        def revision=(val)
          attributes[:version] = val
        end

        def version
          attributes[:version]
        end

        def version=(val)
          attributes[:version] = val
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

        def subject_artifact_uri
          attributes[:subjectArtifactUri]
        end

        def subject_artifact_uri=(val)
          if val
            attributes[:subjectArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:subjectArtifactUri] = nil
          end
        end

        def submitter_uri
          attributes[:submitterUri]
        end

        def submitter_uri=(val)
          if val
            attributes[:submitterUri] = UU::OS::UESURI.new(val)
          else
            attributes[:submitterUri] = nil
          end
        end

        def author_uri
          attributes[:authorUri]
        end

        def author_uri=(val)
          if val
            attributes[:authorUri] = UU::OS::UESURI.new(val)
          else
            attributes[:authorUri] = nil
          end
        end

        def referrer_artifact_uri
          attributes[:referrerArtifactUri]
        end

        def referrer_artifact_uri=(val)
          if val
            attributes[:referrerArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:referrerArtifactUri] = nil
          end
        end

        def sent_time
          attributes[:sentTime]
        end

        def sent_time=(val)
          attributes[:sentTime] = val
        end

      end
    end
  end
end